%%% 6.836 Research Assignment #1. Main script file for Simulator_R

close all
clear all

%Robot Definition

sr=struct('xr',0,'yr',0,'ar',0,'rr',2,'as1',-30/180*pi,'as2',0,'as3',30/180*pi,'body',[],'sensors',[]);

signals=struct('values',[],'dimensions',0);
data=struct('time',[],'signals',signals);

sObs=struct('xo',[],'yo',[],'ro',[]);

sr=DrawRobot(sr,0,0,0,[]);
hold on;

%Obstacles - you should consider modifying these for your test cases

XOBS=[-30 20 30];
YOBS=[20 -10 10];
ROBS=[4,3,6];

sObs.xo=XOBS;
sObs.yo=YOBS;
sObs.ro=ROBS;

DrawObstacle(sObs); 

hold off;

axis([-40 40 -40 40]);
grid on;
axis equal;

%Return sensor readings (i.e., detect objects)

[SL,SM,SR]=detectobs(sr,sObs);
EncR=0;
EncL=0;

%initial random value
prev_rnumber = rand;

%The simulator runs for 50 timesteps
for i=1:100
   
    %random wire value - from a uniform distribution in the interval (0.0, 1.0)-every ten steps
    if mod(i,10)==0
        rnumber=rand;        
        prev_rnumber=rnumber;
    else
        rnumber=prev_rnumber;
    end
    
    signals.values=[EncL,EncR,SL,SM,SR,rnumber];
    signals.dimensions=6;
    
    data.time=i;
    data.signals=signals;
    
    %Call Simulink file - this is where your controller goes
    sim stestX
    
    
    EncL=simout.signals.values(30,1);
    EncR=simout.signals.values(30,2);
    
    sr=DrawRobot(sr,1,EncL,EncR,sObs); 
    V(i,:)=[sr.xr,sr.yr];
    [SL,SM,SR]=detectobs(sr,sObs);
    
    [i,SL,SM,SR, EncL, EncR]
    
    % Remove Pause if needed
    pause   
end

%Plot trajectory in the end
[my,mx]=size(V);
if (my>0)
   hold on; 
    plot(V(:,1),V(:,2));
    hold off;
end

